Pre-release. HostCraft is in testing and not yet for sale. These docs describe the current build and may change. Join the waitlist to hear when it launches.
FTP API
Source: daemon/proto/hostcraft/v1/ftp.proto
FTPService
Section titled “FTPService”FTPService manages FTP(S) logins for accounts (Pure-FTPd, explicit TLS). REST: /api/v1/ftp.
| Method | REST route | Permission | Streaming |
|---|---|---|---|
GetFTPInfo |
GET /api/v1/ftp/info |
FTPAccountRead |
unary |
ListFTPAccounts |
GET /api/v1/ftp/accounts |
FTPAccountRead |
unary |
CreateFTPAccount |
POST /api/v1/ftp/accounts |
FTPAccountCreate |
unary |
GetFTPAccount |
GET /api/v1/ftp/accounts/{id} |
FTPAccountRead |
unary |
UpdateFTPAccount |
PATCH /api/v1/ftp/accounts/{id} |
FTPAccountUpdate |
unary |
DeleteFTPAccount |
DELETE /api/v1/ftp/accounts/{id} |
FTPAccountDelete |
unary |
GetFTPInfo
Section titled “GetFTPInfo”/hostcraft.v1.FTPService/GetFTPInfo
- Request: GetFTPInfoRequest
- Response: FTPInfo
ListFTPAccounts
Section titled “ListFTPAccounts”/hostcraft.v1.FTPService/ListFTPAccounts
- Request: ListFTPAccountsRequest
- Response: ListFTPAccountsResponse
CreateFTPAccount
Section titled “CreateFTPAccount”/hostcraft.v1.FTPService/CreateFTPAccount
- Request: CreateFTPAccountRequest
- Response: FTPAccountResponse
GetFTPAccount
Section titled “GetFTPAccount”/hostcraft.v1.FTPService/GetFTPAccount
- Request: GetFTPAccountRequest
- Response: FTPAccountResponse
UpdateFTPAccount
Section titled “UpdateFTPAccount”/hostcraft.v1.FTPService/UpdateFTPAccount
- Request: UpdateFTPAccountRequest
- Response: FTPAccountResponse
DeleteFTPAccount
Section titled “DeleteFTPAccount”/hostcraft.v1.FTPService/DeleteFTPAccount
- Request: DeleteFTPAccountRequest
- Response: Empty
Messages
Section titled “Messages”CreateFTPAccountRequest
Section titled “CreateFTPAccountRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
login |
string |
2 | full login, or use user + domain |
user |
string |
3 | - |
domain |
string |
4 | - |
password |
string |
5 | - |
dir |
string |
6 | - |
quota_mb |
int64 |
7 | - |
DeleteFTPAccountRequest
Section titled “DeleteFTPAccountRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
Empty is returned by RPCs whose REST route answers with an empty object or 204 No Content.
No fields.
FTPAccount
Section titled “FTPAccount”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
account_id |
string |
2 | - |
login |
string |
3 | - |
domain |
string |
4 | - |
dir |
string |
5 | - |
quota_mb |
int64 |
6 | - |
enabled |
bool |
7 | - |
account_suspended |
bool |
8 | - |
origin |
string |
9 | - |
created_at |
google.protobuf.Timestamp |
10 | - |
updated_at |
google.protobuf.Timestamp |
11 | - |
FTPAccountResponse
Section titled “FTPAccountResponse”| Field | Type | Number | Description |
|---|---|---|---|
account |
FTPAccount |
1 | - |
FTPInfo
Section titled “FTPInfo”| Field | Type | Number | Description |
|---|---|---|---|
host |
string |
1 | - |
port |
int64 |
2 | - |
ftps |
string |
3 | explicit |
passive_ports |
string |
4 | - |
sftp_port |
int64 |
5 | - |
available |
bool |
6 | - |
GetFTPAccountRequest
Section titled “GetFTPAccountRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
GetFTPInfoRequest
Section titled “GetFTPInfoRequest”No fields.
ListFTPAccountsRequest
Section titled “ListFTPAccountsRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
ListFTPAccountsResponse
Section titled “ListFTPAccountsResponse”| Field | Type | Number | Description |
|---|---|---|---|
accounts |
repeated FTPAccount |
1 | - |
UpdateFTPAccountRequest
Section titled “UpdateFTPAccountRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
password |
optional string |
2 | - |
dir |
optional string |
3 | - |
quota_mb |
optional int64 |
4 | - |
enabled |
optional bool |
5 | - |